SystemOrganization addCategory: 'JASVGI'!
SystemOrganization addCategory: 'JASVGI-Graphics'!

Object subclass: #JASVGIObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGIObject commentStamp: '' prior: 0!
Just 
Another 
SVG
Interface!

JASVGIObject subclass: #JASVGIAttribute
	instanceVariableNames: 'svgTagElement attributeName attributeValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
fill: colorValue

	^self name: 'fill' value: colorValue! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
height: height

	^self name: 'height' value: height printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:13'!
parent: aJasvgiTagElement name: stringName value: stringValue

	^super new initialize
		svgTagElement: aJasvgiTagElement; 
		attributeName: stringName;
		attributeValue: stringValue;
		yourself! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
rx: rx

	^self name: 'rx' value: rx printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
ry: ry

	^self name: 'ry' value: ry printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
stroke: strokeValue

	^self name: 'stroke' value: strokeValue! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
width: width

	^self name: 'width' value: width printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
x: xValue

	^self name: 'x' value: xValue printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
y: yValue

	^self name: 'y' value: yValue printString! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
asSvgAttribute

	^attributeName -> self getAttributeValue! !

!JASVGIAttribute methodsFor: 'Accessing' stamp: 'BrunoBB 09/07/2016 07:11'!
attributeName
	^attributeName! !

!JASVGIAttribute methodsFor: 'Updating' stamp: 'BrunoBB 09/07/2016 07:11'!
attributeName: newValue
	attributeName := newValue! !

!JASVGIAttribute methodsFor: 'Accessing' stamp: 'BrunoBB 09/07/2016 07:11'!
attributeValue
	^attributeValue! !

!JASVGIAttribute methodsFor: 'Updating' stamp: 'BrunoBB 09/07/2016 07:11'!
attributeValue: newValue
	attributeValue := newValue! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
getAttributeValue

	(attributeValue class == String) ifFalse: [^attributeValue printString].

	^attributeValue! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:13'!
isStyleAttribute

	^svgTagElement styleAttributesNames includes: attributeName! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ('(', attributeName, ' > ', self getAttributeValue,')')! !

!JASVGIAttribute methodsFor: 'Accessing' stamp: 'BrunoBB 09/07/2016 07:11'!
svgTagElement
	^svgTagElement! !

!JASVGIAttribute methodsFor: 'Updating' stamp: 'BrunoBB 09/07/2016 07:11'!
svgTagElement: newValue
	svgTagElement := newValue! !

JASVGIObject subclass: #JASVGICanvas
	instanceVariableNames: 'xmlCanvas svgTag svgObjects svgMarkers svgFigures svgLines svgGroups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGICanvas commentStamp: '' prior: 0!
Methods name convention order:
at
id
r
rx
ry
width
height
widthPx
strokeWidth
stroke
fillColor
color!

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 09:46'!
defaultHeaders

	^OrderedCollection new 
		add: ('xmlns' -> 'http://www.w3.org/2000/svg');
		add: ('xmlns:xlink' -> 'http://www.w3.org/1999/xlink');
		yourself! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 08:27'!
example3
	| canvas points |

	canvas := self newWidth: '1000px' height: '1000px'.
	points := OrderedCollection new 
	add: 0@0; add: 10@10; add: 20@20; add: 30@50;add: 40@80;
	add: 50@78; add:60@52; add: 70@40; add: 60@25; add: 70@10; 
	add: 80@58; add: 90@100; add: 100@30; add: 110@20;
	yourself.

	canvas drawCurve: points at: 100@100 widthPx: '2px' stroke: 'black' fillColor: 'black'.

	^canvas contents! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/28/2016 08:22'!
example4
	| canvas points |

	canvas := self newWidth: '1000px' height: '1000px'.
	points := OrderedCollection new 
	add: 0@0; add: 20@10; add: 40@20; add: 60@50;add: 80@80;
	add: 100@78; add:120@52; add: 140@40; add: 160@25; add: 180@90; 
	add: 200@58; add: 220@100; add: 240@30; add: 260@20;
	yourself.

	canvas drawVerticalCurveWithCircles: points strokeWidth: '3px' stroke: 'black' fillColor: 'black'.

	^canvas contents! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/28/2016 08:20'!
example5
	| canvas points |

	canvas := self newWidth: '1000px' height: '1000px'.
	points := OrderedCollection new 
	add: 0@0; add: 20@10; add: 40@20; add: 60@50;add: 80@80;
	add: 100@78; add:120@52; add: 140@40; add: 160@25; add: 180@90; 
	add: 200@58; add: 220@100; add: 240@30; add: 260@20;
	yourself.

	canvas drawHorizontalCurveWithCircles: points strokeWidth: '3px' stroke: 'black' fillColor: 'black'.

	^canvas contents! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 09:46'!
new

	^super new initialize setDefaultCanvas! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/21/2016 08:02'!
newWidth: width height: height

	^self newWidth: width height: height backcolor: 'none'! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 10/02/2016 09:50'!
newWidth: width height: height backcolor: backcolor

	^self newWidth: width height: height backcolor: backcolor overflow: false! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 10/02/2016 09:50'!
newWidth: width height: height backcolor: backcolor overflow: aBoolean

	^self newWidth: width height: height backcolor: backcolor overflowX: aBoolean overflowY: aBoolean! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 10/02/2016 09:55'!
newWidth: width height: height backcolor: backcolor overflowX: overflowX overflowY: overflowY
	| configuration style |

	style := 'background-color: ', backcolor,';'.
	overflowX ifTrue: [style := style, ' overflow-x: auto;'].
	overflowY ifTrue: [style := style, ' overflow-y: auto;']. 
	
	configuration := self defaultHeaders 
		add: ('width' -> width); 
		add: ('height' -> height); 
		add: ('style' -> style); 
		yourself.

	^super new 
		initialize 
		setCanvasWith: configuration
		yourself! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 10/02/2016 09:50'!
newWidth: width height: height overflow: aBoolean

	^self newWidth: width height: height backcolor: 'none' overflow: aBoolean! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:28'!
addFigure: tagFigure
	"The receiver add a new figure <tagFigure>"

	^svgFigures at: tagFigure id put: tagFigure! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:31'!
addFigure: aJasvgiTagFigure toGroup: groupNamed
	"The receiver the figure <aJasvgiTagFigure> to the group named <groupNamed>.
	Groups <JASVGITagGroup> are used to group figures to apply the same transformation on all of them."

	svgGroups 
		at: groupNamed 
		ifPresent: [:jasvgiTagGroup | jasvgiTagGroup addFigure: aJasvgiTagFigure]
		ifAbsent: [svgGroups at: groupNamed put: (JASVGITagGroup newNamed: groupNamed with: aJasvgiTagFigure) ].

	svgFigures removeKey: aJasvgiTagFigure id ifAbsent: []. "if the figure is in a group --> is not in the general canvas <svgObjects>"
	svgLines removeKey: aJasvgiTagFigure id ifAbsent: []. 	"if the figure is in a group --> is not in the general canvas <svgObjects>"

	^aJasvgiTagFigure! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:32'!
addLine: tagPath
	"The receiver add a path tag <JASVGITagPath>"

	^svgLines at: tagPath id put: tagPath! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:33'!
addMarker: tagMarker
	"The receiver add a marker tag.
	Markers are used with path tags to set start and end figures of each line. (see senders)"

	^svgMarkers at: tagMarker id put: tagMarker! !

!JASVGICanvas methodsFor: 'connectors' stamp: 'BrunoBB 09/27/2016 15:39'!
connect: figureOne to: figureTwo
	"The receiver connect the start figure <figureOne> with en figure <figureTwo>"

	^self drawLineM: 
		(Array 
				with: (figureOne getPointToConnectTo: figureTwo)
				with: (figureTwo getPointToConnectTo: figureOne))! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/27/2016 15:42'!
contents
	"The receiver answer all it's contents. It produce a valid svg string which include receiver's figures."
	
	svgTag with: [
		self tag: 'defs' with: [svgMarkers do: [:each | each drawOn: self]].

		(svgGroups orderedKeys select: [:e | e notNil]) do:[:key | | tagGroup |
			tagGroup := svgGroups at: key.
			tagGroup drawOn: self.

		].
		(svgFigures orderedKeys select: [:e | e notNil]) do:[:key | | svgFigureTag |
			svgFigureTag := svgFigures at: key.
			svgFigureTag drawOn: self.
		].
		(svgLines orderedKeys select: [:e | e notNil]) do:[:key | | svgLineTag |
			svgLineTag := svgLines at: key.
			svgLineTag drawOn: self.
		].
	].

	^xmlCanvas contents! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:34'!
defaultHeaders
	"Add default headers to the SVG string"

	^self class defaultHeaders! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/27/2016 15:42'!
draw: aJASVGITagFigure
	"Store <aJASVGITagFigure> to be drawn"

	^aJASVGITagFigure drawOnListOf: self! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/27/2016 15:44'!
draw: aJASVGITagFigure in: groupNamed
	"Store <aJASVGITagFigure> to be drawn in a group named <groupNamed>"

	^aJASVGITagFigure drawOnListOf: self in: groupNamed! !

!JASVGICanvas methodsFor: 'circles' stamp: 'BrunoBB 09/28/2016 08:10'!
drawCircleAt: aPoint id: id r: radius strokeWidth: strokeWidth stroke: stroke fillColor: fillColor 
	"The receiver draw a circle with:
	radius: <radius> 
	at: <aPoint> 
	figure id: <id>
	fill color: <fillColor>
	stroke color: <stroke>
	stroke width: <strokeWidth>"

	^self draw: (JASVGITagCircle 
						newAt: aPoint 
						id: id 
						r: radius
						fillColor: fillColor 
						stroke: stroke 
						strokeWidth: strokeWidth)! !

!JASVGICanvas methodsFor: 'circles' stamp: 'BrunoBB 09/28/2016 08:12'!
drawCircleAt: aPoint r: radius stroke: stroke fillColor: fillColor
	"The receiver draw a circle with:
	radius: <radius> 
	at: <aPoint> 
	fill color: <fillColor>
	stroke color: <stroke>"

	^self drawCircleAt: aPoint r: radius strokeWidth: '1' stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'circles' stamp: 'BrunoBB 09/28/2016 08:11'!
drawCircleAt: aPoint r: radius strokeWidth: strokeWidth stroke: stroke fillColor: fillColor 
	"The receiver draw a circle with:
	radius: <radius> 
	at: <aPoint> 
	fill color: <fillColor>
	stroke color: <stroke>
	stroke width: <strokeWidth>"

	^self drawCircleAt: aPoint id: UUID new asString r: radius strokeWidth: strokeWidth stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'connectors' stamp: 'BrunoBB 09/11/2016 09:46'!
drawConnectorFrom: initialPoint to: endPoint

	^self draw: (JASVGITagConnector from: initialPoint to: endPoint)! !

!JASVGICanvas methodsFor: 'connectors' stamp: 'BrunoBB 09/11/2016 09:46'!
drawConnectorFromId: initialId toId: endId

	^self draw: (JASVGITagConnector fromId: initialId toId: endId)! !

!JASVGICanvas methodsFor: 'connectors' stamp: 'BrunoBB 09/11/2016 09:46'!
drawConnectorFromId: initialId toId: endId id: id

	^self draw: (JASVGITagConnector fromId: initialId toId: endId id: id)! !

!JASVGICanvas methodsFor: 'curves' stamp: 'BrunoBB 09/24/2016 16:30'!
drawCurve: points at: aPoint

	^self drawCurve: points at: aPoint widthPx: '1px' stroke: 'black' fillColor: 'black'! !

!JASVGICanvas methodsFor: 'curves' stamp: 'BrunoBB 09/28/2016 07:16'!
drawCurve: points at: aPoint id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"The receiver draw a curve using the collection points <points> with id <id> with width in px <widthPx> stroke color <stroke> and fill color <fillColor>"
	| curve translatedPoints |

	translatedPoints := points collect: [:each | each x @ each y negated].

	curve := self draw: (JASVGITagPath newCurve: translatedPoints id: id widthPx: widthPx stroke: stroke fillColor: fillColor).

	curve transform: ('translate(', aPoint x printString, ',',aPoint y printString, ')').

	^curve! !

!JASVGICanvas methodsFor: 'curves' stamp: 'BrunoBB 09/28/2016 07:17'!
drawCurve: points at: aPoint widthPx: widthPx stroke: stroke fillColor: fillColor 
	"The receiver draw a curve using the collection points <points> with width in px <widthPx> stroke color <stroke> and fill color <fillColor>"

	^self drawCurve: points at: aPoint id: UUID new asString widthPx: widthPx stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'curves' stamp: 'BrunoBB 09/28/2016 08:15'!
drawCurvePoints: points at: aPoint id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	|  translatedPoints |

	translatedPoints := points collect: [:each | each x @ each y negated].

	translatedPoints do: [:each | | point |
		point := self drawCircleAt: each r: 2 strokeWidth: strokeWidth stroke: stroke fillColor: fillColor.
		point transform: ('translate(', aPoint x printString, ',',aPoint y printString, ')').
	].! !

!JASVGICanvas methodsFor: 'curves' stamp: 'BrunoBB 09/28/2016 08:15'!
drawCurvePoints: points at: aPoint stroke: stroke fillColor: fillColor

	^self drawCurvePoints: points at: aPoint id: UUID new asString strokeWidth: '1px' stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'curves' stamp: 'BrunoBB 09/28/2016 08:15'!
drawCurvePoints: points at: aPoint strokeWidth: strokeWidth stroke: stroke fillColor: fillColor

	^self drawCurvePoints: points at: aPoint id: UUID new asString strokeWidth: '1px' stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'circles' stamp: 'BrunoBB 09/28/2016 08:13'!
drawEllipseAt: aPoint id: id rx: rx ry: ry strokeWidth: strokeWidth stroke: stroke fillColor: fillColor 
	"The receiver draw a ellipse with:
	radius x: <rx> 
	radius y: <ry> 
	at: <aPoint> 
	figure id: <id>
	fill color: <fillColor>
	stroke color: <stroke>
	stroke width: <strokeWidth>"

	^self draw: (JASVGITagEllipse
						newAt: aPoint 
						id: id 
						rx: rx 
						ry: ry 
						fillColor: fillColor 
						stroke: stroke 
						strokeWidth: strokeWidth)! !

!JASVGICanvas methodsFor: 'curves with circles' stamp: 'BrunoBB 09/28/2016 08:18'!
drawHorizontalCurveWithCircles: points r: r id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	"The receiver draw curve where at each <points> x value it draw a circle with radius <r> stroke <stroke> fill color <fillColor> and stroke witdth <strokeWidth>.
	Then from each cirlcle draw a vertical line to Y axis "
	|  translatedPoints transformString lastPoint axisX axisY marker maxYvalue axisText yShift |

	maxYvalue := (points asSortedCollection: [:a :b | a y >= b y]) first y + 30.

	transformString := 'translate(20,20)'.
	yShift := 0.
	translatedPoints := points collect: [:each | each y @ each x].

	marker := self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	marker transform: transformString.

	translatedPoints do: [:each | | point line textX textY |
		point := self drawCircleAt: each r: r strokeWidth: strokeWidth stroke: stroke fillColor: fillColor.
		line := self drawLineFrom: (0 @ each y) to: each.
		textX := self drawText: each y printString at: (-20 @ each y).
		textY := self drawText: each x printString at: ((each x + 10) @ each y + 5).
		point transform: transformString.
		line transform: transformString.
		textY transform: transformString.
		textX transform: transformString.
	].
	lastPoint := translatedPoints last.

	axisX := self drawLineFrom: (0 @ 0) to: (maxYvalue + 20) @ 0.
	axisX setMarkerEnd: 'arrow'.
	axisX transform: transformString.
	axisText := self drawText: (maxYvalue - 30) printString at: ((maxYvalue + 20) @ -5).
	axisText transform: transformString.

	axisY := self drawLineFrom: (0 @ 0) to: (0 @ (lastPoint y + 20)).
	axisY setMarkerEnd: 'arrow'.
	axisY transform: transformString.
	axisText := self drawText: (lastPoint y) printString at: (5 @ (lastPoint y + 20)).
	axisText transform: transformString.! !

!JASVGICanvas methodsFor: 'curves with circles' stamp: 'BrunoBB 09/28/2016 08:18'!
drawHorizontalCurveWithCircles: points r: r strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	"The receiver draw curve where at each <points> x value it draw a circle with radius <r> stroke <stroke> fill color <fillColor> and stroke witdth <strokeWidth>.
	Then from each cirlcle draw a vertical line to Y axis "

	^self drawHorizontalCurveWithCircles: points r: r id: UUID new asString strokeWidth: strokeWidth stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'curves with circles' stamp: 'BrunoBB 09/28/2016 08:20'!
drawHorizontalCurveWithCircles: points strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	"The receiver draw curve where at each <points> x value it draw a circle with radius <r> stroke <stroke> fill color <fillColor> and stroke witdth <strokeWidth>.
	Then from each cirlcle draw a vertical line to Y axis "

	^self drawHorizontalCurveWithCircles: points r: 3 id: UUID new asString strokeWidth: strokeWidth stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/18/2016 14:08'!
drawLine: pointsString id: id widthPx: widthPx stroke: stroke fillColor: fillColor 

	^self draw: (JASVGITagPath newLine: pointsString id: id widthPx: widthPx stroke: stroke fillColor: fillColor)! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:35'!
drawLineFrom: startPoint to: endPoint
	"The receiver draw a line from start <startPoint> to end <endPoint> "

	^self drawLineFrom: startPoint to: endPoint id: UUID new asString! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:35'!
drawLineFrom: startPoint to: endPoint color: color
	"The receiver draw a line from start <startPoint> to end <endPoint> with fill color <fillColor>"

	^self drawLineFrom: startPoint to: endPoint id: UUID new asString color: color! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:35'!
drawLineFrom: startPoint to: endPoint id: id
	"The receiver draw a line from start <startPoint> to end <endPoint> with id <id>"

	^self drawLineFrom: startPoint to: endPoint id: id widthPx: '1px' stroke: 'black' fillColor: 'black'! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:36'!
drawLineFrom: startPoint to: endPoint id: id color: color
	"The receiver draw a line from start <startPoint> to end <endPoint> with id <id> and fill color <color>"

	^self drawLineFrom: startPoint to: endPoint id: id widthPx: '1px' stroke: 'black' fillColor: color! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:34'!
drawLineFrom: startPoint to: endPoint id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"The receiver draw a line from start <startPoint> to end <endPoint> with id <id> width in px <widthPx> stroke color <stroke> and fill color <fillColor>"

	^self draw: (JASVGITagLine newLineFrom: startPoint to: endPoint id: id widthPx: widthPx stroke: stroke fillColor: fillColor)! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:34'!
drawLineFrom: startPoint to: endPoint widthPx: widthPx stroke: stroke fillColor: fillColor 
	"The receiver draw a line from start <startPoint> to end <endPoint> width in px <widthPx> stroke color <stroke> and fill color <fillColor>"

	^self drawLineFrom: startPoint to: endPoint id: UUID new asString widthPx: widthPx stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:39'!
drawLineM: points
	"The receiver draw a line (svg type M) using points in collection <points>"

	^self drawLineM: points id: UUID new asString! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:39'!
drawLineM: points id: id
	"The receiver draw a line (svg type M) using points in collection <points> and id <id>"

	^self drawLineM: points id: id widthPx: '1' stroke: 'gray' fillColor: 'black'! !

!JASVGICanvas methodsFor: 'lines' stamp: 'BrunoBB 09/28/2016 07:38'!
drawLineM: points id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"The receiver draw a line (svg type M) using points in collection <points> with id <id> line width in px <widthPx> stroke color <stroke> and fill color <fillColor>"

	^self draw: (JASVGITagPath newLineM: points id: id widthPx: widthPx stroke: stroke fillColor: fillColor)! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 10/01/2016 08:59'!
drawRectangleAt: aPoint id: id width: width height: height stroke: stroke fillColor: fillColor
	"The receiver draw a rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self draw: (JASVGITagRectangle 
						newAt: aPoint 
						id: id 
						width: width 
						height: height 
						stroke: stroke
						fillColor: fillColor)! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 10/01/2016 09:04'!
drawRectangleAt: aPoint id: id width: width height: height strokeWidth: widthPx stroke: stroke fillColor: fillColor
	"The receiver draw a rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self draw: (JASVGITagRectangle 
						newAt: aPoint 
						id: id 
						width: width 
						height: height 
						strokeWidth: widthPx
						stroke: stroke
						fillColor: fillColor)! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 09/28/2016 08:25'!
drawRectangleAt: aPoint width: width height: height stroke: stroke fillColor: fillColor
	"The receiver draw a rectangle a <aPoint> with height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRectangleAt: aPoint id: UUID new asString width: width height: height stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 10/01/2016 09:16'!
drawRoundRectangleAt: aPoint id: id width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor
	"The receiver draw a round rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self draw: (JASVGITagRectangle 
						newRoundAt: aPoint 
						id: id 
						width: width 
						height: height 
						rx: rx
						ry: ry
						strokeWidth: widthPx
						stroke: stroke
						fillColor: fillColor)! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 10/01/2016 08:54'!
drawRoundRectangleAt: aPoint id: id width: width height: height stroke: stroke fillColor: fillColor
	"The receiver draw a round rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRoundRectangleAt: aPoint id: id width: width height: height strokeWidth: '1px' stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 10/01/2016 09:16'!
drawRoundRectangleAt: aPoint id: id width: width height: height strokeWidth: widthPx stroke: stroke fillColor: fillColor
	"The receiver draw a round rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRoundRectangleAt: aPoint id: id width: width height: height rx: 5 ry: 5 strokeWidth: widthPx stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 10/01/2016 09:17'!
drawRoundRectangleAt: aPoint width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor
	"The receiver draw a round rectangle a <aPoint> with id <id> height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRoundRectangleAt: aPoint id: UUID new asString width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 10/01/2016 08:19'!
drawRoundRectangleAt: aPoint width: width height: height stroke: stroke fillColor: fillColor 
	"The receiver draw a round rectangle a <aPoint> with height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRoundRectangleAt: aPoint id: UUID new asString width: width height: height stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'rectangles' stamp: 'BrunoBB 10/01/2016 09:01'!
drawRoundRectangleAt: aPoint width: width height: height strokeWidth: widthPx stroke: stroke fillColor: fillColor 
	"The receiver draw a round rectangle a <aPoint> with height <height> width <width> fill color <fillColor> and stroke color <stroke>"

	^self drawRoundRectangleAt: aPoint id: UUID new asString width: width height: height strokeWidth: widthPx stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'text' stamp: 'BrunoBB 09/28/2016 07:43'!
drawText: aString at: aPoint 
	"The receiver draw the string <aString> at <aPoint>"

	^self drawText: aString at: aPoint id: UUID new asString! !

!JASVGICanvas methodsFor: 'text' stamp: 'BrunoBB 10/01/2016 10:52'!
drawText: aString at: aPoint color: color
	"The receiver draw the string <aString> at <aPoint> with id <id> "

	^self drawText: aString at: aPoint id: UUID new asString  textSizePx: '10px' color: color! !

!JASVGICanvas methodsFor: 'text' stamp: 'BrunoBB 09/28/2016 07:43'!
drawText: aString at: aPoint id: id 
	"The receiver draw the string <aString> at <aPoint> with id <id> "

	^self drawText: aString at: aPoint id: id textSizePx: '10px'! !

!JASVGICanvas methodsFor: 'text' stamp: 'BrunoBB 10/01/2016 10:50'!
drawText: aString at: aPoint id: id textSizePx: textSizePx
	"The receiver draw the string <aString> at <aPoint> with id <id> and text size <textSizePx> "

	^self drawText: aString at: aPoint id: id textSizePx: textSizePx color: 'black'! !

!JASVGICanvas methodsFor: 'text' stamp: 'BrunoBB 10/01/2016 10:50'!
drawText: aString at: aPoint id: id textSizePx: textSizePx color: color
	"The receiver draw the string <aString> at <aPoint> with id <id> and text size <textSizePx> "

	^self draw: (JASVGITagText newText: aString at: aPoint id: id textSizePx: textSizePx color: color)! !

!JASVGICanvas methodsFor: 'text' stamp: 'BrunoBB 09/28/2016 07:44'!
drawText: aString at: aPoint textSizePx: textSizePx
	"The receiver draw the string <aString> at <aPoint> with text size <textSizePx> "

	^self drawText: aString at: aPoint id: UUID new asString textSizePx: textSizePx! !

!JASVGICanvas methodsFor: 'curves with circles' stamp: 'BrunoBB 09/28/2016 08:22'!
drawVerticalCurveWithCircles: points id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	"The receiver draw curve where at each <points> x value it draw a circle with radius <r> stroke <stroke> fill color <fillColor> and stroke witdth <strokeWidth>.
	Then from each cirlcle draw a vertical line to X axis "

	^self drawVerticalCurveWithCircles: points r: 3 id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'curves with circles' stamp: 'BrunoBB 09/29/2016 10:32'!
drawVerticalCurveWithCircles: points r: r id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	"The receiver draw curve where at each <points> x value it draw a circle with radius <r> stroke <stroke> fill color <fillColor> and stroke witdth <strokeWidth>.
	Then from each cirlcle draw a vertical line to X axis "
	|  translatedPoints transformString lastPoint axisX axisY marker maxYvalue axisText |

	maxYvalue := (points asSortedCollection: [:a :b | a y >= b y]) first y + 30.
	transformString := 'translate(20,', maxYvalue printString, ')'.
	translatedPoints := points collect: [:each | each x @ each y negated].

	marker := self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	marker transform: transformString.

	translatedPoints do: [:each | | point line textX textY |
		point := self drawCircleAt: each r: r  strokeWidth: strokeWidth stroke: stroke fillColor: fillColor.
		line := self drawLineFrom: (each x @ 0) to: each.
		textX := self drawText: each x abs printString at: ((each x - 5) @ 12).
		textY := self drawText: each y abs printString at: ((each x - 5) @ (each y - 10)).
		point transform: transformString.
		line transform: transformString.
		textY transform: transformString.
		textX transform: transformString.
	].
	lastPoint := translatedPoints last.

	axisX := self drawLineFrom: (0 @ 0) to: (lastPoint x + 20) @ 0.
	axisX setMarkerEnd: 'arrow'.
	axisX transform: transformString.
	axisText := self drawText: lastPoint x abs printString at: ((lastPoint x + 20) @ -5).
	axisText transform: transformString.

	axisY := self drawLineFrom: (0 @ 0) to: (0 @ (maxYvalue negated + 10)).
	axisY setMarkerEnd: 'arrow'.
	axisY transform: transformString.
	axisText := self drawText: (maxYvalue abs - 30) printString at: (5 @ (maxYvalue negated + 20)).
	axisText transform: transformString.! !

!JASVGICanvas methodsFor: 'curves with circles' stamp: 'BrunoBB 09/28/2016 08:23'!
drawVerticalCurveWithCircles: points strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	"The receiver draw curve where at each <points> x value it draw a circle with radius <r> stroke <stroke> fill color <fillColor> and stroke witdth <strokeWidth>.
	Then from each cirlcle draw a vertical line to X axis "

	^self drawVerticalCurveWithCircles: points r: 3 id: UUID new asString strokeWidth: strokeWidth stroke: stroke fillColor: fillColor! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:34'!
getGroupNamed: aString
	"Answer a group named <aString> if none answer <nil>"

	^svgGroups at: aString ifAbsent: [nil]! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:35'!
getSvgObjectId: id
	"Answer the svg object with id <id> if none answer <nil>"

	^svgObjects at: id ifAbsent: [nil]! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:36'!
height
	"Answer the height of the special instance variable <svgTag>"

	^svgTag attributes at: 'height' ifAbsent: [nil]! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 09:46'!
initialize

	super initialize.

	xmlCanvas := XMLWriter new.
	svgObjects := OrderPreservingDictionary new.
	svgMarkers := OrderPreservingDictionary new.
	svgLines := OrderPreservingDictionary new.
	svgFigures := OrderPreservingDictionary new.
	svgGroups := OrderPreservingDictionary new.! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:37'!
setCanvasWith: headers
	"Set the headers of the receiver with <headers>"

	svgTag := self tag: 'svg' attributes: headers.! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:37'!
setDefaultCanvas
	"The receiver set the instance variable <svgTag>. Which is the initial tag."

	svgTag := self tag: 'svg' attributes: self defaultHeaders.! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 09:46'!
svgFigures
	^svgFigures! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 09:46'!
svgFigures: newValue
	svgFigures := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 09:46'!
svgGroups
	^svgGroups! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 09:46'!
svgGroups: newValue
	svgGroups := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 09:46'!
svgLines
	^svgLines! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 09:46'!
svgLines: newValue
	svgLines := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 09:46'!
svgMarkers
	^svgMarkers! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 09:46'!
svgMarkers: newValue
	svgMarkers := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 09:46'!
svgObjects
	^svgObjects! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 09:46'!
svgObjects: newValue
	svgObjects := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 09:46'!
svgTag
	^svgTag! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 09:46'!
svgTag: newValue
	svgTag := newValue! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/27/2016 15:45'!
tag: tagName attributes: aCollection
	"The receiver creates a new tag named <tagName> with attributes <aCollection> (a collection of associations) "

	^xmlCanvas tag: tagName attributes: aCollection! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/27/2016 15:46'!
tag: tagName attributes: aCollection with: textOrBlock
	"The receiver creates a new tag named <tagName> with contents defined in <textOrBlock> and with attributes <aCollection> (a collection of associations)."

	^xmlCanvas tag: tagName attributes: aCollection with: textOrBlock! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/27/2016 15:46'!
tag: tagName with: textOrBlock
	"The receiver creates a new tag named <tagName> with contents defined in <textOrBlock>."

	^xmlCanvas tag: tagName with: textOrBlock! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:38'!
width
	"Answer the height of the special instance variable <svgTag>"

	^svgTag attributes at: 'width' ifAbsent: [nil]! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 09:46'!
xmlCanvas
	^xmlCanvas! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 09:46'!
xmlCanvas: newValue
	xmlCanvas := newValue! !

JASVGICanvas subclass: #JASVGIGraphCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI-Graphics'!

!JASVGIGraphCanvas commentStamp: '' prior: 0!
Methods name convention order:
at
id
r
rx
ry
width
height
widthPx
strokeWidth
stroke
fillColor
color!

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 14:32'!
example1
 | dict |

	dict := Dictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawVerticalBarGraph: dict at: 10@20 maxHeight: 180 width: 30)
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:14'!
example10
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'china' put: 28;
		at: 'uruguay' put: 44;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'los angeles' put: 6; at: 'oregon' put: 14; at: 'orlando' put: 10; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 20; at: 'las piedras' put: 24; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawJoin: splitDict 
			verticalBarGraph: dict 
			at: 15@15 
			maxHeight: 200 
			width: 20 
			transform: 'translate(50,400),scale(1.5,1.5)') 
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example11
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'china' put: 28;
		at: 'uruguay' put: 44;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'los angeles' put: 6; at: 'oregon' put: 14; at: 'orlando' put: 10; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 20; at: 'las piedras' put: 24; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawJoin: splitDict 
			horizontalBarGraph: dict 
			at: 15@15 
			maxWidth: 200 
			width: 20 
			transform: 'translate(20,20),scale(1.5,1.5)') 
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:35'!
example12
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'china' put: 28;
		at: 'uruguay' put: 44;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'oregon' put: 14; at: 'orlando' put: 10; at: 'los angeles' put: 6; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 23; at: 'las piedras' put: 21; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawJoin: splitDict 
			horizontalBarGraph: dict 
			at: 15@15 
			maxWidth: 400 
			width: 15
			transform: 'translate(20,10),scale(1.5,1.5)') 
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/23/2016 05:06'!
example13
 | dict canvas |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px' backcolor: 'lightgray'.
	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 80;
		at: 'md' put: 70;
		at: 'mef' put: 50;
		at: 'opp' put: 50;
		at: 'msp' put: 50;
		at: 'mt' put: 60.	
	canvas
		drawDonutAngles: dict 
		at: 10@10 
		radius: 80
		width: 60
		backcolor: 'white'
		transform: 'translate(100,100)'.

	canvas
		drawDonutAngles: dict 
		at: 10@10 
		radius: 80
		width: 50
		backcolor: 'white'
		transform: 'translate(400,100)'.

	canvas
		drawDonutAngles: dict 
		at: 10@10 
		radius: 80
		width: 40
		backcolor: 'white'
		transform: 'translate(100,300)'.

	canvas
		drawDonutAngles: dict 
		at: 10@10 
		radius: 80
		width: 30
		backcolor: 'white'
		transform: 'translate(400,300)'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/29/2016 05:15'!
example14
 | dict canvas workingDays |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px' backcolor: 'lightgray'.
	dict := OrderPreservingDictionary new.
	workingDays := Dictionary new.
	workingDays at: 1 put: 20; at: 2 put: 15; at: 3 put: 8; at: 4 put: 30; at: 5 put: 22; at: 6 put: 15; at: 7 put: 30; at: 8 put: 4; at: 9 put: 19; at: 10 put: 8; at: 11 put: 14; 
at: 12 put: 1; at: 13 put: 4; at: 14 put: 28; at: 15 put: 22; at: 28 put: 15; at: 45 put: 17; at: 53 put: 22; at: 60 put: 8; at: 70 put: 9; at: 75 put: 8; at: 83 put: 19; at: 90 put: 17;
at: 103 put: 21; at: 115 put: 12; at: 160 put: 26; at: 175 put: 17.
 	canvas drawVerticalDaysAt: 30@30 
				from: (Date fromString: '09/30/2016')
				to: ((Date fromString: '09/30/2016') addDays: 365) 
				workingDays: workingDays
				width: 10 
				color: 'green'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/29/2016 05:17'!
example15
 | dict canvas workingDays |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px' backcolor: 'lightgray'.
	dict := OrderPreservingDictionary new.
	workingDays := Dictionary new.
	workingDays at: 1 put: 20; at: 2 put: 15; at: 3 put: 8; at: 4 put: 30; at: 5 put: 22; at: 6 put: 15; at: 7 put: 30; at: 8 put: 4; at: 9 put: 19; at: 10 put: 8; at: 11 put: 14; 
at: 12 put: 1; at: 13 put: 4; at: 14 put: 28; at: 15 put: 22; at: 21 put: 15; at: 23 put: 17; at: 25 put: 22; at: 28 put: 8; at: 29 put: 9; at: 30 put: 17.

 	canvas drawVerticalDaysAt: 30@30 
				from: (Date fromString: '09/01/2016')
				to: (Date fromString: '09/30/2016')
				workingDays: workingDays
				width: 20 
				color: 'green'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 10/10/2016 13:46'!
example16
	| dict canvas sd |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px' backcolor: 'lightgray'.
	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 80;
		at: 'mef' put: 70;
		at: 'opp' put: 100;
		at: 'msp' put: 50;
		at: 'mt' put: 60.	
	sd := OrderPreservingDictionary new.
	sd at: 'miem-1' put: 40; at: 'miem-2' put: 40; at: 'mef-1' put: 30; at: 'mef-2' put: 30; 
at: 'mef-3' put: 10; at: 'opp-1' put: 40; at: 'opp-2' put: 15; at: 'opp-3' put: 15; at: 'opp-4' put: 10; 
at: 'opp-5' put: 10; at: 'opp-6' put: 10; at: 'msp-1' put: 30;at: 'msp-2' put: 20; at: 'mt-1' put: 20; 
at: 'mt-2' put: 30; at: 'mt-3' put: 10.

	canvas
		drawDoubleDonutAngles: dict 
		subAngles: sd 
		at: 10@10
		radius: 80 
		backcolor: 'lightgray' 
		transform: 'translate(150,150)'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example2
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 30;
		at: 'usa' put: 25;
		at: 'china' put: 20;
		at: 'india' put: 20;
		at: 'vietnam' put: 5.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPiesDesc: dict at: 120@120 zoom: 1) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example3
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 80;
		at: 'md' put: 70;
		at: 'mef' put: 50;
		at: 'opp' put: 50;
		at: 'msp' put: 50;
		at: 'mt' put: 60.	

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPieAngles: dict at: 10@10 radius: 80) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 07:41'!
example4
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 45;
		at: 'md' put: 20;
		at: 'mef' put: 15;
		at: 'opp' put: 10;
		at: 'msp' put: 5;
		at: 'mt' put: 5.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawPiePercentage: dict at: 10@10 radius: 80) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example5
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawVerticalBarGraph: dict at: 15@200 maxHeight: 180 width: 30) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example6
 | dict |

	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 30;
		at: 'china' put: 28;
		at: 'india' put: 25.

	^((JASVGIGraphCanvas newWidth: '1000px' height: '1000px') drawHorizontalBarGraph: dict at: 15@15 maxWidth: 600 width: 30) contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 16:04'!
example7
  | dict canvas |

	canvas := JASVGIGraphCanvas newWidth: '1000px' height: '1000px'.
	dict := OrderPreservingDictionary new.
	dict at: 'miem' put: 30;
		at: 'md' put: 20;
		at: 'mef' put: 15;
		at: 'opp' put: 10;
		at: 'msp' put: 5;
		at: 'mvotma' put: 8;
		at: 'mi' put: 7;
		at: 'mt' put: 5.

	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(100,100)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(100,300)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(450,100)'.
	canvas drawPiePercentage: dict at: 10@10 radius: 80 transform: 'translate(450,300)'.

	^canvas contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/22/2016 05:13'!
example8
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'china' put: 28;
		at: 'uruguay' put: 44;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'los angeles' put: 6; at: 'oregon' put: 14; at: 'orlando' put: 10; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 20; at: 'las piedras' put: 24; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawInnerSplit: splitDict 
			verticalBarGraph: dict 
			at: 15@15 
			maxHeight: 200 
			width: 30 
			transform: 'translate(50,400),scale(1.5,1.5)') 
		contents! !

!JASVGIGraphCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/21/2016 16:32'!
example9
 | dict splitDict |

	splitDict := OrderPreservingDictionary new.
	dict := OrderPreservingDictionary new.
	dict at: 'rusia' put: 60;
		at: 'usa' put: 50;
		at: 'uruguay' put: 44;
		at: 'china' put: 28;
		at: 'india' put: 25.

	splitDict at: 'rusia' put: (OrderPreservingDictionary new at: 'moscow' put: 30; at: 'st pertersburg' put: 20; at: 'vladigostok' put: 10;yourself);
		at: 'usa' put: (OrderPreservingDictionary new at: 'new york' put: 20; at: 'oregon' put: 14; at: 'orlando' put: 10; at: 'los angeles' put: 6; yourself);
		at: 'china' put: (OrderPreservingDictionary new at: 'pekin' put: 24; at: 'hong kong' put: 4; yourself);
		at: 'uruguay' put: (OrderPreservingDictionary new at: 'montevideo' put: 23; at: 'las piedras' put: 21; yourself);
		at: 'india' put: (OrderPreservingDictionary new at: 'new delhi' put: 15; at: 'bombay' put: 8; at: 'mumba' put: 2 ;yourself).

	^((self newWidth: '1000px' height: '1000px') 
			drawInnerSplit: splitDict 
			horizontalBarGraph: dict 
			at: 15@15 
			maxWidth: 500 
			width: 20
			transform: 'translate(20,20),scale(1.4,1.4)') 
		contents! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 09/28/2016 07:46'!
colorPalette
	"Answer anArray with a list of color to be used by the receiver"

	^#('aliceblue' 'beige' 'brown' 'burlywood' 'cadetblue' 'chocolate' 'coral' 'cornsilk' 'crimson' 'darkcyan' 'darkgoldenrod' 'darkgray' 'darkgreen' 'darkkhaki' 'darkolivegreen'  'darkred' 'darkslateblue' 'darkslategray' 'firebrick' 'gold' 'goldenrod' 'gray' 'lightblue' 'indigo' 'ivory' 'khaki' 'lavender' 'lightcyan' 'lightgoldenrodyellow' 'lightgray' 'olive' 'peru' 'red' 'saddlebrown' 'steelblue' 'tan')! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/29/2016 07:11'!
drawDonutAngles: anglesDictionary at: aPoint radius: radius width: width backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| pie donuts |

	"self drawRectangleAt: 0@0 height: self height width: self width fillColor: backcolor stroke: 'none'."

	pie := self drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform.

	donuts := self drawCircleAt: 0@0 r: width stroke: 'black' fillColor: backcolor.

	donuts transform: transform.! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/23/2016 05:08'!
drawDonutPercentage: percentageDictionary at: aPoint radius: radius width: width backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawDonutAngles: (percentageDictionary collect: [:per | (per * 360) / 100])
			at: aPoint
			radius: radius 
			width: width
			backcolor: backcolor 
			transform: transform! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/29/2016 07:09'!
drawDonutQuantity: quantityDictionary at: aPoint radius: radius width: width backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| pie donuts |

	pie := self drawPieQuantity: quantityDictionary at: aPoint radius: radius transform: transform.

	donuts := self drawCircleAt: 0@0 r: width stroke: 'black' fillColor: backcolor.

	donuts transform: transform.! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 13:48'!
drawDoubleDonutAngles: anglesDictionary subAngles: subAngles at: aPoint radius: radius backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawDoubleDonutAngles: anglesDictionary subAngles: subAngles showSub: true at: aPoint radius: radius backcolor: backcolor transform: transform! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 13:51'!
drawDoubleDonutAngles: anglesDictionary subAngles: subAngles showSub: aBoolean at: aPoint radius: radius backcolor: backcolor transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| dictionaries blankCircle colorDictionary subColorDictionary opacityDictionary maxValue mainDonutRadius |

	dictionaries := self getDictionaryOpacityColorFor: anglesDictionary subValues: subAngles.
	colorDictionary := dictionaries at: 1.
	subColorDictionary := dictionaries at: 2.
	opacityDictionary := dictionaries at: 3.
	maxValue := anglesDictionary asSortedCollection last.

	mainDonutRadius :=  aBoolean 
		ifTrue: [self drawPieAngles: subAngles at: aPoint radius: (radius * 1.5) colors: subColorDictionary opacityDictionary: opacityDictionary transform: transform maxValue: maxValue.
					radius]
		ifFalse: [radius * 1.5].	

	self drawPieAngles: anglesDictionary at: aPoint radius: mainDonutRadius colors: colorDictionary opacityDictionary: Dictionary new transform: transform maxValue: maxValue.

	blankCircle := self drawCircleAt: 0@0 r: (radius//2) stroke: 'black' fillColor: backcolor.
	blankCircle transform: transform.! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 11:09'!
drawDoublePieAngles: mainAnglesDictionary subAngles: subAnglesDictionary at: aPoint radius: radius transform: transform maxValue: maxValue
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| colorsDictionary |

	colorsDictionary := self getDictionaryColorFor: mainAnglesDictionary.

	self drawPieAngles: mainAnglesDictionary at: aPoint radius: radius colors: colorsDictionary transform: transform maxValue: maxValue.! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/20/2016 04:09'!
drawHorizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"

	^self drawHorizontalBarGraph: aDictionary 
			at: aPoint 
			maxWidth: maxWidth 
			width: width 
			transform: 'translate(20,20)'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:26'!
drawHorizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width transform: transform
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis xShift group axisRange groupName |

	groupName := 'horizontalBar'.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).

	axis := self drawLineFrom: x@y to: (x +  maxWidth + 20) @ y.
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	xShift := maxWidth // 5.
	axisRange := x + xShift.

	1 to: 5 do: [:index | | line text |
		"draw scale Y bar"
		line := self drawLineFrom: (axisRange @ (aPoint y - 5)) to: (axisRange @ (aPoint y + 5)).
		text := self drawText: (maxValue * index // 5) printString at: ((axisRange - 3) @ (aPoint x - 10)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName.
		axisRange := axisRange + xShift]. 

	"draw rectangle bars"
	y := y + 15.
	aDictionary keysAndValuesDo: [:key :value | | text text2 graph graphHeight |
		text := self drawText: key at: (x - 25) @ y textSizePx: '10px'.
		text2 := self drawText: value printString at: ((x - 25) @ (y + 10)) textSizePx: '10px'.
		graphHeight := value * maxWidth //  maxValue.
		graph := self drawRectangleAt: (x @ y) width: graphHeight height: width stroke: 'black' fillColor: self colorPalette randomPeek.
		self addFigure: graph toGroup: groupName.
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		y := y + width + 10.
	].! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/21/2016 16:10'!
drawInnerSplit: splitDictionary horizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph."
	

	^self drawInnerSplit: splitDictionary 
			horizontalBarGraph: aDictionary 
			at: aPoint 
			maxWidth: maxWidth 
			width: width 
			transform: 'translate(20,20)'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:27'!
drawInnerSplit: splitDictionary horizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width transform: transform
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis xShift group axisRange groupName colorPalette |

	colorPalette := self colorPalette asOrderedCollection.
	groupName := 'horizontalBar'.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).

	axis := self drawLineFrom: x@y to: (x +  maxWidth + 20) @ y.
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	xShift := maxWidth // 5.
	axisRange := x + xShift.

	1 to: 5 do: [:index | | line text |
		"draw scale Y bar"
		line := self drawLineFrom: (axisRange @ (aPoint y - 5)) to: (axisRange @ (aPoint y + 5)).
		text := self drawText: (maxValue * index // 5) printString at: ((axisRange - 3) @ (aPoint x - 10)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName.
		axisRange := axisRange + xShift]. 

	"draw rectangle bars"
	y := y + 25.
	aDictionary keysAndValuesDo: [:key :value | | text text2 graphHeight splitX color opacity |
		text := self drawText: key at: (x - 25) @ y textSizePx: '10px'.
		text2 := self drawText: value printString at: ((x - 25) @ (y + 10)) textSizePx: '10px'.
		graphHeight := value * maxWidth //  maxValue.
		splitX := x.
		"graph := self drawRectangleAt: (x @ y) height: width width: graphHeight fillColor: self colorPalette randomPeek stroke: 'black'."
		opacity := 1.
		color := colorPalette randomPeek.
		colorPalette remove: color.
		colorPalette isEmpty ifTrue: [colorPalette := self colorPalette asOrderedCollection].
		(splitDictionary at: key) keysAndValuesDo: [:splitKey :splitValue | | splitText splitText2 innerWidth splitGraph |
			innerWidth := splitValue * maxWidth //  maxValue.
			splitGraph := self drawRectangleAt: (splitX @ y) width: innerWidth height: width stroke: 'black' fillColor: color.
			splitGraph add: (JASVGIAttribute parent: splitGraph name: 'fill-opacity' value: opacity printString).
			opacity := opacity - 0.2.
			splitText := self drawText: splitKey at: (((splitX + (innerWidth//2)) - 20) @ (y-8)) textSizePx: '6px'.
			splitText2 := self drawText: splitValue printString at: (((splitX + (innerWidth//2)) - 20) @ (y-3)) textSizePx: '6px'.
			self addFigure: splitGraph toGroup: groupName.
			self addFigure: splitText toGroup: groupName.
			self addFigure: splitText2 toGroup: groupName.
			splitX := splitX + innerWidth.
		]. 
		"self addFigure: graph toGroup: groupName."
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		y := y + width + 20.
	].! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/21/2016 14:10'!
drawInnerSplit: splitDictionary verticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"

	^self drawInnerSplit: splitDictionary 
			verticalBarGraph: aDictionary 
			at: aPoint maxHeight: maxHeight 
			width: width 
			transform: 'translate(20,', (maxHeight + 20) printString,')'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:27'!
drawInnerSplit: splitDictionary verticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width transform: transform
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis yShift group groupName colorPalette |

	groupName := UUID new asString.
	colorPalette := self colorPalette asOrderedCollection.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x + 35.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).
	axis := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y -  maxHeight - 20)).
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	yShift := maxHeight // 5.
	1 to: 5 do: [:index | | axisRange line text |
		"draw scale Y bar"
		axisRange := y - (yShift * index) .
		line := self drawLineFrom: ((aPoint x - 5) @ axisRange) to: ((aPoint x + 5) @ axisRange).
		text := self drawText: (maxValue * index // 5) printString at: ((aPoint x - 10) @ (axisRange - 3)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName]. 

	"draw rectangle bars"
	aDictionary keysAndValuesDo: [:key :value | | text text2 graphHeight splitY color opacity |
		text := self drawText: key at: (x @ (y + 15)) textSizePx: '10px'.
		text2 := self drawText: value printString at: (x @ (y + 30)) textSizePx: '10px'.
		graphHeight := value * maxHeight //  maxValue.
		color := colorPalette randomPeek.
		colorPalette remove: color.
		colorPalette isEmpty ifTrue: [colorPalette := self colorPalette asOrderedCollection].
		opacity := 0.5.
"		graph := self drawRectangleAt: (x @ (y - graphHeight)) height: graphHeight width: width fillColor: self colorPalette randomPeek stroke: 'black'."
		splitY := y - graphHeight.
		(splitDictionary at: key) keysAndValuesDo: [:splitKey :splitValue | | splitText splitText2 innerHeight splitGraph |
			innerHeight := splitValue * maxHeight //  maxValue.
			splitGraph := self drawRectangleAt: (x @ splitY) width: width height: innerHeight stroke: 'black' fillColor: color.
			splitGraph add: (JASVGIAttribute parent: splitGraph name: 'fill-opacity' value: opacity printString).
			opacity := opacity + 0.2.
			splitY := splitY + innerHeight.
			splitText := self drawText: splitKey at: ((x-20) @ (splitY - (innerHeight//2))) textSizePx: '6px'.
			splitText2 := self drawText: splitValue printString at: ((x-20) @ (splitY + 8 - (innerHeight//2))) textSizePx: '6px'.
			self addFigure: splitGraph toGroup: groupName.
			self addFigure: splitText toGroup: groupName.
			self addFigure: splitText2 toGroup: groupName.
		]. 

	"	self addFigure: graph toGroup: groupName."
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		x := x + width + 30.
	].! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:27'!
drawJoin: joinDictionary horizontalBarGraph: aDictionary at: aPoint maxWidth: maxWidth width: width transform: transform
	"The receiver draw a Horizontally oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max horizontal bar is defined by <maxWidth> where the max value in <aDictionary> will be rendered as maxWidth in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis xShift group axisRange groupName colorPalette |

	colorPalette := self colorPalette asOrderedCollection.
	groupName := 'horizontalBar'.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x.
	maxValue := 0.
	joinDictionary do: [:eachDict | | maxElem |
		maxElem := eachDict asSortedCollection asSortedCollection last.
		(maxElem > maxValue) ifTrue: [maxValue := maxElem]].
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).

	axis := self drawLineFrom: x@y to: (x +  maxWidth + 20) @ y.
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	xShift := maxWidth // 5.
	axisRange := x + xShift.

	1 to: 5 do: [:index | | line text |
		"draw scale Y bar"
		line := self drawLineFrom: (axisRange @ (aPoint y - 5)) to: (axisRange @ (aPoint y + 5)).
		text := self drawText: (maxValue * index // 5) printString at: ((axisRange - 3) @ (aPoint x - 10)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName.
		axisRange := axisRange + xShift]. 

	"draw rectangle bars"
	y := y + 25.
	aDictionary keysAndValuesDo: [:key :value | | text text2 graphHeight color opacity |
		text := self drawText: key at: (x - 25) @ y textSizePx: '10px'.
		text2 := self drawText: value printString at: ((x - 25) @ (y + 10)) textSizePx: '10px'.
		graphHeight := value * maxWidth //  maxValue.
		opacity := 1.
		color := colorPalette randomPeek.
		colorPalette remove: color.
		colorPalette isEmpty ifTrue: [colorPalette := self colorPalette asOrderedCollection].
		(joinDictionary at: key) keysAndValuesDo: [:splitKey :splitValue | | splitText splitText2 innerWidth splitGraph |
			innerWidth := splitValue * maxWidth //  maxValue.
			splitGraph := self drawRectangleAt: (x @ y) width: innerWidth height: width stroke: 'black' fillColor: color.
			splitGraph add: (JASVGIAttribute parent: splitGraph name: 'fill-opacity' value: opacity printString).
			opacity := opacity - 0.2.
			splitText := self drawText: splitKey at: ((x + innerWidth + 5) @ (y + 5)) textSizePx: '6px'.
			splitText2 := self drawText: splitValue printString at: ((x + innerWidth + 5)@ (y+12)) textSizePx: '6px'.
			self addFigure: splitGraph toGroup: groupName.
			self addFigure: splitText toGroup: groupName.
			self addFigure: splitText2 toGroup: groupName.
			y := y + width + 5.
		]. 
		"self addFigure: graph toGroup: groupName."
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		y := y + width.
	].! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:28'!
drawJoin: joinDictionary verticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width transform: transform
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis yShift group groupName colorPalette |

	groupName := UUID new asString.
	colorPalette := self colorPalette asOrderedCollection.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x + 20.
	maxValue := 0.
	joinDictionary do: [:eachDict | | maxElem |
		maxElem := eachDict asSortedCollection asSortedCollection last.
		(maxElem > maxValue) ifTrue: [maxValue := maxElem]].
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).
	axis := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y -  maxHeight - 20)).
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	yShift := maxHeight // 5.
	1 to: 5 do: [:index | | axisRange line text |
		"draw scale Y bar"
		axisRange := y - (yShift * index) .
		line := self drawLineFrom: ((aPoint x - 5) @ axisRange) to: ((aPoint x + 5) @ axisRange).
		text := self drawText: (maxValue * index // 5) printString at: ((aPoint x - 10) @ (axisRange - 3)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName]. 

	"draw rectangle bars"
	aDictionary keysAndValuesDo: [:key :value | | text text2 graphHeight splitY color opacity |
		text := self drawText: key at: (x @ (y + 25)) textSizePx: '10px'.
		text2 := self drawText: value printString at: (x @ (y + 35)) textSizePx: '10px'.
		graphHeight := value * maxHeight //  maxValue.
		color := colorPalette randomPeek.
		colorPalette remove: color.
		colorPalette isEmpty ifTrue: [colorPalette := self colorPalette asOrderedCollection].
		opacity := 0.5.
		splitY := y.
		(joinDictionary at: key) keysAndValuesDo: [:splitKey :splitValue | | splitText splitText2 innerHeight splitGraph |
			innerHeight := splitValue * maxHeight //  maxValue.
			splitGraph := self drawRectangleAt: (x @ (splitY - innerHeight)) width: width height: innerHeight stroke: 'black' fillColor: color.
			splitGraph add: (JASVGIAttribute parent: splitGraph name: 'fill-opacity' value: opacity printString).
			opacity := opacity + 0.2.
			splitText := self drawText: splitKey at: ((x-5) @ (splitY - innerHeight - 10)) textSizePx: '6px'.
			splitText2 := self drawText: splitValue printString at: ((x + (width//2)) @ (splitY + 8)) textSizePx: '6px'.
			self addFigure: splitGraph toGroup: groupName.
			self addFigure: splitText toGroup: groupName.
			self addFigure: splitText2 toGroup: groupName.
			x := x + width + 5. "separate join bars"
		]. 
		x := x + width.
	"	self addFigure: graph toGroup: groupName."
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
	].! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/20/2016 09:15'!
drawPieAngles: anglesDictionary at: aPoint radius: radius
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary 
			at: aPoint 
			radius: radius 
			transform: 'translate(', (radius + 20) printString, ',', (radius + 20) printString,')'! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 13:32'!
drawPieAngles: anglesDictionary at: aPoint radius: radius colors: colorsDictionary opacityDictionary: opacityDictionary transform: transform maxValue: maxValue
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."
	| group angleSum startPoint labelsX labelsY random groupName |

	random := Random new.
	startPoint := radius @ 0.
	groupName := UUID new asString.
	group := JASVGITagGroup newNamed: groupName id: UUID new asString.
	group transform: transform.
	svgGroups at: groupName put: group.
	angleSum := 0.
	labelsX := radius + aPoint x + 40.
	labelsY := aPoint y - radius.

	anglesDictionary keysAndValuesDo: [:label :eachAngle | | actualValue line pointsString calculatedPoint color percentage rect text yShift graphText |
		color := colorsDictionary at: label.
		calculatedPoint := self getArcPointFor: eachAngle angleSum: angleSum radius: radius.
		pointsString := PrintStream on: String new.
		pointsString nextPutAll: 'M0,0 '. "center of the circle"
		pointsString nextPutAll: (startPoint x printString, ',', startPoint y printString).
		pointsString nextPutAll: ' A', radius printString, ',',radius printString.
		pointsString nextPutAll: ' 1'.
		(eachAngle > 180) ifTrue: [pointsString nextPutAll: ' 1 0 '] ifFalse: [pointsString nextPutAll: ' 0 0 '].
		yShift := (eachAngle = 360) "360" ifTrue: ['0.5'] ifFalse: [calculatedPoint y printString].
		pointsString nextPutAll: (calculatedPoint x printString, ',', yShift, ' Z').
		line := self drawLine: pointsString contents id: UUID new asString widthPx: '1px' stroke: 'black' fillColor: color.
		line addAttribute: ('opacity'-> (opacityDictionary at: label ifAbsent: [1])).
		self addFigure: line toGroup: groupName.
		angleSum := angleSum + eachAngle.
		startPoint := calculatedPoint.
		rect := self drawRoundRectangleAt: labelsX - 15 @ labelsY width: 15 height: 15 stroke: 'black' fillColor: color.
		self addFigure: rect toGroup: groupName.
		percentage := (eachAngle * 100) / 360.
		actualValue := ((maxValue * percentage) / 100) printShowingDecimalPlaces: 2.
		percentage := percentage printShowingDecimalPlaces: 2.
		graphText := (maxValue = 100) ifTrue: [label, ' - ', percentage,'%'] ifFalse: [label, ' - ', percentage,'% - ', actualValue].
		text := self drawText: graphText at: labelsX @ labelsY + 10.
		self addFigure: text toGroup: groupName.
		labelsY := labelsY + 20.
	].
	^group! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 12:38'!
drawPieAngles: anglesDictionary at: aPoint radius: radius colors: colorsDictionary transform: transform maxValue: maxValue
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary 
			at: aPoint 
			radius: radius 
			colors: colorsDictionary 
			opacityDictionary: Dictionary new
			transform: transform 
			maxValue: maxValue! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/24/2016 07:44'!
drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform maxValue: 100! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 10/10/2016 11:07'!
drawPieAngles: anglesDictionary at: aPoint radius: radius transform: transform maxValue: maxValue
	"The receiver draw a Pie Graph with values in <anglesDictionary> where the key is the label and the value is the angle.
	The total sum must be 360 and begin in 0 radian and anti clockwork.
	The radius of the pie is defined by <radius>."

	^self drawPieAngles: anglesDictionary 
			at: aPoint 
			radius: radius 
			colors: (self getDictionaryColorFor: anglesDictionary)
			transform: transform 
			maxValue: maxValue! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 13:36'!
drawPiePercentage: percentageDictionary at: aPoint radius: radius
	"The receiver draw a Pie Graph with values in <percentageDictionary> where the key is the label and the value is the percentage.
	The total sum must be 100.
	The radius of the pie is defined by <radius>."

	^self 
		drawPieAngles: (percentageDictionary collect: [:per | (per * 360) / 100]) "convert percentaje to pie angle"
		at: aPoint
		radius: radius! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/19/2016 15:56'!
drawPiePercentage: percentageDictionary at: aPoint radius: radius transform: transform
	"The receiver draw a Pie Graph with values in <percentageDictionary> where the key is the label and the value is the percentage.
	The total sum must be 100.
	The radius of the pie is defined by <radius>."

	^self 
		drawPieAngles: (percentageDictionary collect: [:per | (per * 360) / 100]) "convert percentaje to pie angle"
		at: aPoint
		radius: radius
		transform: transform! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/24/2016 07:44'!
drawPieQuantity: quantityDictionary at: aPoint radius: radius transform: transform
	"The receiver draw a Pie Graph with values in <quantityDictionary> where the key is the label and the value is the actual value.
	The radius of the pie is defined by <radius>."
	| totalValue |

	totalValue := quantityDictionary inject: 0 into: [:sum :each | sum + each].

	^self 
		drawPieAngles: (quantityDictionary collect: [:value | (value * 360) / totalValue]) "convert percentaje to pie angle"
		at: aPoint
		radius: radius
		transform: transform
		maxValue: totalValue! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:18'!
drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom 

	^self drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom showTotal: true! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/28/2016 08:57'!
drawPies: collectionPercentage at: aPoint asc: aBoolean zoom: zoom showTotal: showTotal
	| xShift yText prevRadius switch group |

	group := JASVGITagGroup newNamed: 'pies'.
	group transform: 'translate(', aPoint x printString, ',', aPoint y printString,')'.
	yText := aPoint y.
	switch := true.

	showTotal 
	ifTrue: [ | circle text |
		circle := self drawCircleAt: aPoint r: (100 * zoom) stroke: 'black' fillColor: self colorPalette randomPeek.
		text := self drawText: 'Total - 100%' at: aPoint.
		self addFigure: circle toGroup: 'pies'.
		self addFigure: text toGroup: 'pies'.
		prevRadius := (100 * zoom).
		xShift := aPoint x + prevRadius]
	ifFalse: [xShift := aPoint x].

	(aBoolean ifTrue: [collectionPercentage asSortedCollection] ifFalse: [collectionPercentage asSortedCollection reverse])
		do: [:eachValue | | key radius circle text |
			yText := switch ifTrue: [aPoint y + 10] ifFalse: [aPoint y - 10].
			key := collectionPercentage keyAtValue: eachValue.
			radius := eachValue * zoom.
			xShift := xShift + radius + 10.
			circle := self drawCircleAt: (xShift @ aPoint y) r: radius stroke: 'black' fillColor: self colorPalette randomPeek.
			text := self drawText: (key, ' ', eachValue printString, '%') at: ((xShift - radius + 10) @ yText).
			self addFigure: circle toGroup: 'pies'.
			self addFigure: text toGroup: 'pies'.
			prevRadius := radius.
			xShift := xShift + prevRadius + 10.
			switch := switch not.
		].! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:05'!
drawPiesAsc: collectionPercentage at: aPoint zoom: zoom

	^self drawPies: collectionPercentage at: aPoint asc: true zoom: zoom! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:19'!
drawPiesAsc: collectionPercentage at: aPoint zoom: zoom showTotal: aBoolean

	^self drawPies: collectionPercentage at: aPoint asc: true zoom: zoom showTotal: aBoolean! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:05'!
drawPiesDesc: collectionPercentage at: aPoint zoom: zoom

	^self drawPies: collectionPercentage at: aPoint asc: false zoom: zoom! !

!JASVGIGraphCanvas methodsFor: 'pies' stamp: 'BrunoBB 09/18/2016 12:20'!
drawPiesDesc: collectionPercentage at: aPoint zoom: zoom showTotal: aBoolean

	^self drawPies: collectionPercentage at: aPoint asc: false zoom: zoom showTotal: aBoolean! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/20/2016 04:06'!
drawVerticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"

	^self drawVerticalBarGraph: aDictionary 
			at: aPoint 
			maxHeight: maxHeight 
			width: width 
			transform: 'translate(20,', (maxHeight + 20) printString,')'! !

!JASVGIGraphCanvas methodsFor: 'bar' stamp: 'BrunoBB 09/28/2016 08:28'!
drawVerticalBarGraph: aDictionary at: aPoint maxHeight: maxHeight width: width transform: transform
	"The receiver draw a Vertically oriented Bar Graph with values in <aDictionary> where the key is the label and the value is value.
	The max vertical bar is defined by <maxHeight> where the max value in <aDictionary> will be rendered as maxHeight in the graph.
	The witdh of each bar is defined by <width>"
	| lateralIndex x y maxValue axis yShift group groupName |

	groupName := UUID new asString.
	group := JASVGITagGroup newNamed: groupName.
	group transform: transform.
	svgGroups at: groupName put: group.
	lateralIndex := 1.
	y := aPoint y.
	x := aPoint x + 25.
	maxValue := aDictionary asSortedCollection last.
	"draw graph axis Y only"
	self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	self addMarker: (self markerClass newCircleAt: 5@5 id: 'circle' width: 10 height: 10).
	axis := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y -  maxHeight - 20)).
	self addFigure: axis toGroup: groupName.
	axis setMarkerStart: 'circle'. 
	axis setMarkerEnd: 'arrow'. 
	yShift := maxHeight // 5.
	1 to: 5 do: [:index | | axisRange line text |
		"draw scale Y bar"
		axisRange := y - (yShift * index) .
		line := self drawLineFrom: ((aPoint x - 5) @ axisRange) to: ((aPoint x + 5) @ axisRange).
		text := self drawText: (maxValue * index // 5) printString at: ((aPoint x - 10) @ (axisRange - 3)).
		self addFigure: line toGroup: groupName.
		self addFigure: text toGroup: groupName]. 

	"draw rectangle bars"
	aDictionary keysAndValuesDo: [:key :value | | text text2 graph graphHeight |
		text := self drawText: key at: (x @ (y + 15)) textSizePx: '10px'.
		text2 := self drawText: value printString at: (x @ (y + 30)) textSizePx: '10px'.
		graphHeight := value * maxHeight //  maxValue.
		graph := self drawRectangleAt: (x @ (y - graphHeight)) width: width height: graphHeight stroke: 'black' fillColor: self colorPalette randomPeek.
		self addFigure: graph toGroup: groupName.
		self addFigure: text toGroup: groupName.
		self addFigure: text2 toGroup: groupName.
		lateralIndex := lateralIndex + 1.
		x := x + width + 10.
	].! !

!JASVGIGraphCanvas methodsFor: 'days' stamp: 'BrunoBB 09/30/2016 08:04'!
drawVerticalCurveFrom: startDate for: days r: r id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor
	""

	^self drawVerticalCurveFrom: startDate for: days r: r id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor xShift: 20 groupedBy: 10! !

!JASVGIGraphCanvas methodsFor: 'days' stamp: 'BrunoBB 09/30/2016 08:01'!
drawVerticalCurveFrom: startDate for: days r: r id: id strokeWidth: strokeWidth stroke: stroke fillColor: fillColor xShift: xShift groupedBy:  anInteger
	""
	|  translatedPoints sortedDays transformString lastPoint axisX axisY marker maxYvalue axisText previousPoint axisXlabel switch dayShift maxDays |

	sortedDays := days asSortedCollection: [:a :b | a y >= b y].
	maxYvalue := sortedDays first y + 30.
	maxDays := sortedDays last x * anInteger.
	transformString := 'translate(20,', maxYvalue printString, ')'.
	translatedPoints := days collect: [:each | (each x * xShift) @ each y negated].

	marker := self addMarker: (self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height: 10).
	marker transform: transformString.

	previousPoint := 0@0.
	switch := true.
	dayShift := translatedPoints first x.
	translatedPoints do: [:each | | point line textY textX currentDate |
		dayShift := (dayShift < (each x // xShift)) ifTrue: [dayShift] ifFalse: [dayShift + anInteger].
		currentDate := startDate addDays: dayShift.
		axisXlabel := currentDate day printString, (currentDate monthName first: 3), (currentDate year printString last: 2) .
		point := self drawCircleAt: each r: r  strokeWidth: strokeWidth stroke: stroke fillColor: fillColor.
		textX := self drawText: axisXlabel at: ((each x - 5) @ (switch ifTrue: [10] ifFalse: [20])).
		switch := switch not.
		textY := self drawText: each y abs printString at: ((each x - 5) @ (each y - 10)).
		line := self drawLineFrom: previousPoint to: (point x @ point y).
		previousPoint := (each x @ each y).
		point transform: transformString.
		textY transform: transformString.
		textX transform: transformString.
		line transform: transformString.
	].
	lastPoint := translatedPoints last.

	axisX := self drawLineFrom: (0 @ 0) to: (lastPoint x + 20) @ 0.
	axisX setMarkerEnd: 'arrow'.
	axisX transform: transformString.
	axisText := self drawText: lastPoint x abs printString at: ((lastPoint x + 20) @ -5).
	axisText transform: transformString.

	axisY := self drawLineFrom: (0 @ 0) to: (0 @ (maxYvalue negated + 10)).
	axisY setMarkerEnd: 'arrow'.
	axisY transform: transformString.! !

!JASVGIGraphCanvas methodsFor: 'days' stamp: 'BrunoBB 09/29/2016 11:00'!
drawWorkingDays: workingDays at: aPoint from: startDate to: endDate width: width color: color
	"The receiver draw a vertical working day graph from <startDate> to <endDate> where <workingDays> dictionary key's is the day number and value is the color intensity.
	The width of each rectangle day is <width> and color is <color>"
	
	^self drawWorkingDays: workingDays at: aPoint from: startDate to: endDate width: width color: color dayHasContent: false! !

!JASVGIGraphCanvas methodsFor: 'days' stamp: 'BrunoBB 10/01/2016 11:18'!
drawWorkingDays: workingDays at: aPoint from: startDate to: endDate width: width color: color dayHasContent: aBoolean
	"The receiver draw a vertical working day graph from <startDate> to <endDate> where <workingDays> dictionary key's is the day number and value is the color intensity.
	The width of each rectangle day is <width> and color is <color>"
	| numberOfDays group groupName currentPosition weekCounter maxValue monthName scaleRect scaleText scaleOpacity sortedWorkingDays |

	weekCounter := 0.
	sortedWorkingDays := workingDays asSortedCollection.
	maxValue :=  sortedWorkingDays last.
	groupName := 'verticalWorkingDay'.
	group := JASVGITagGroup newNamed: groupName.
	group transform: 'translate(', aPoint x printString, ',', aPoint y printString, ')'.

	numberOfDays := endDate asDays - startDate asDays.
	currentPosition := aPoint.

	0 to: (numberOfDays - 1) do: [:dayIndex | | value rectDay opacity |
		((startDate addDays: dayIndex) monthName = monthName) 
		ifFalse: [monthName := (startDate addDays: dayIndex) monthName. 
					"draw the name of the months"
					self drawText: (monthName first: 3) at: (currentPosition x @ (aPoint y - 10))].
		weekCounter := weekCounter + 1.
		value := workingDays at: dayIndex ifAbsent: [0].
		opacity := ((value = maxValue) ifFalse: [(value / maxValue) max: 0.05] ifTrue: [1]) asFloat.
		rectDay := ((startDate addDays: dayIndex) day = 1) 
						ifFalse: [self drawRectangleAt: currentPosition width: width height: width stroke: color fillColor: color] 
						ifTrue: [self drawRoundRectangleAt: currentPosition width: width height: width rx: 5 ry: 5 strokeWidth: '1px' stroke: 'darkgreen' fillColor: color].
		rectDay add: (JASVGIAttribute parent: rectDay name: 'opacity' value: opacity).
		self addFigure: rectDay toGroup: groupName.
		(aBoolean and: [value ~= 0]) 
		ifTrue: [self drawText: value printString at: ((currentPosition x + 5) @ (currentPosition y + 12)) color: 'darkgreen']. 
		"draw the named of the days"
		((aPoint x = currentPosition x) and: [weekCounter odd])  "is the first column ?"
		ifTrue: [self drawText: ((startDate addDays: dayIndex) dayOfWeekName first: 3) at: ((aPoint x - 25) @ (currentPosition y + 7))]. 
		(weekCounter = 7)
		ifTrue: [weekCounter := 0.
			dayIndex odd ifTrue: [self drawText: (startDate addDays: dayIndex) day printString at: (currentPosition x @ (currentPosition y + width + 12))].
			currentPosition := (currentPosition x + width + 5) @ aPoint y] 
		ifFalse: [currentPosition := (currentPosition x) @ (currentPosition y + width + 5)].
	].
		currentPosition := aPoint x @ (aPoint y + (7 * width) + 50). 
		scaleRect := self drawRoundRectangleAt: currentPosition width: width height: width stroke: 'darkgreen' fillColor: 'darkgreen'.
		scaleOpacity := ((sortedWorkingDays first / maxValue) max: 0.05) asFloat.
		scaleRect add: (JASVGIAttribute parent: scaleRect name: 'opacity' value: scaleOpacity).
		scaleText := self drawText: sortedWorkingDays first printString at: ((currentPosition x + 5) @ (currentPosition y + 12)) color: 'green'.
		self addFigure: scaleRect toGroup: groupName.
		self addFigure: scaleText toGroup: groupName.

		currentPosition := (aPoint x + width + 5) @ (aPoint y + (7 * width) + 50). 
		scaleRect := self drawRoundRectangleAt: currentPosition width: width height: width stroke: 'darkgreen' fillColor: 'darkgreen'.
		scaleRect add: (JASVGIAttribute parent: scaleRect name: 'opacity' value: 1).
		scaleText := self drawText: maxValue printString at: ((currentPosition x + 5) @ (currentPosition y + 12)) color: 'green'.
		self addFigure: scaleRect toGroup: groupName.
		self addFigure: scaleText toGroup: groupName.! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/20/2016 09:37'!
getArcPointCoordinatesFor: totalAngle radius: radius
	"The rceiver calculate the coordinates for the point in the circle where the angle is <totalAngle> and circle has radius <radius>"
	| x y |

	x := (((totalAngle * DecimalFloat pi) / 180) cos) * radius.

	y := (((totalAngle * DecimalFloat pi) / 180) sin) * radius.

	^x @ y! !

!JASVGIGraphCanvas methodsFor: 'pie' stamp: 'BrunoBB 09/20/2016 09:29'!
getArcPointFor: angle angleSum: angleSum radius: radius
	"Answer the end point <aPoint> for the arc with angle <angle> and circle angle completion <angleSum> with radius <radius> "
	| endPoint totalAngle |

	totalAngle := angleSum + angle. "the angle of the arc is: from <angleSum> to <totalAngle>"
	"formula: 
	x= cos(radian angle) x radius. 											
	y= sin(radian angle) x radius "
	endPoint := self getArcPointCoordinatesFor: totalAngle radius: radius.

	"border cases"
	(totalAngle = 90) ifTrue: [endPoint x: 0; y: radius negated].
	(totalAngle = 270) ifTrue: [endPoint x: 0; y: radius].
 	(totalAngle = 0 or: [totalAngle = 360])  ifTrue: [endPoint y: 0; x: radius].
 	(totalAngle = 180)  ifTrue: [endPoint y: 0; x: radius negated].

	((totalAngle < 90) or: [totalAngle > 270]) 
	ifTrue: [endPoint x: endPoint x abs] 
	ifFalse: [endPoint x: endPoint x abs negated].
	(totalAngle > 180) 
	ifTrue: [endPoint y: endPoint y abs] 
	ifFalse: [endPoint y: endPoint y abs negated].

	^endPoint! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 10/10/2016 13:38'!
getDictionaryColorFor: dictionary
	| colorsDictionary palette random |

	random := Random new.
	colorsDictionary := Dictionary new.
	palette := self colorPalette asOrderedCollection.
	dictionary keys do: [:key | | color |
		color := palette randomPeek: random.
		colorsDictionary at: key put: color.
		palette remove: color ifAbsent: [].
		palette isEmpty ifTrue: [palette := self colorPalette asOrderedCollection]. 
		].

	^colorsDictionary! !

!JASVGIGraphCanvas methodsFor: 'other' stamp: 'BrunoBB 10/10/2016 13:34'!
getDictionaryOpacityColorFor: anglesDictionary subValues: subAnglesDictionary
	""
	| colorsDictionary subColorDictionary opacityDictionary index currentAngle subKeys subValue |

	opacityDictionary := Dictionary new.
	subColorDictionary := Dictionary new.
	currentAngle := 0.
	subValue := 0.
	index := 1.
	colorsDictionary := self getDictionaryColorFor: anglesDictionary.
	subKeys := subAnglesDictionary keys.

	anglesDictionary keysAndValuesDo: [:label :value | | currentCollection opacity |
		currentCollection := OrderedCollection new.
		currentAngle := currentAngle + value.
		opacity := 1.
		[currentAngle > subValue] whileTrue: [
			subValue := subValue + (subAnglesDictionary at: (subKeys at: index)).
			opacity := opacity - 0.2.
			opacityDictionary at: (subKeys at: index) put: opacity.
			subColorDictionary at: (subKeys at: index) put: (colorsDictionary at: label).
			index := index + 1.
		].
	].

	^Array with: colorsDictionary with: subColorDictionary with: opacityDictionary! !

!JASVGIObject class methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 09:47'!
markerClass

	^JASVGITagMarker! !

!JASVGIObject class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 07:28'!
new

	^super new initialize! !

!JASVGIObject class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 09:20'!
styleAttributesNames

	^#('fill' 'stroke' 'stroke-width')! !

!JASVGIObject methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 09:47'!
markerClass

	^self class markerClass! !

JASVGIObject subclass: #JASVGITagElement
	instanceVariableNames: 'id attributes subTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

JASVGITagElement subclass: #JASVGITagConnector
	instanceVariableNames: 'startPoint endPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagConnector class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:12'!
from: startPoint to: endPoint

	^super new initialize
		startPoint: startPoint endPoint: endPoint;
		yourself! !

!JASVGITagConnector class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:20'!
fromId: startId toId: endId

	^super new initialize
		startId: startId endId: endId;
		yourself! !

!JASVGITagConnector class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:23'!
fromId: startId toId: endId id: id

	^super new initialize
		id: id;
		startId: startId endId: endId;
		yourself! !

!JASVGITagConnector methodsFor: 'Accessing' stamp: 'BrunoBB 09/09/2016 05:10'!
endPoint
	^endPoint! !

!JASVGITagConnector methodsFor: 'Updating' stamp: 'BrunoBB 09/09/2016 05:10'!
endPoint: newValue
	endPoint := newValue! !

!JASVGITagConnector methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:20'!
startId: startId endId: endId
	| attributesCollection pointsStream |

	pointsStream := PrintStream on: String new.
	pointsStream nextPutAll: 'url(#', startId, '),'.
	pointsStream nextPutAll: 'url(#', endId, ')'.
	
	attributesCollection := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'points' value: pointsStream contents);
		yourself.

	self setAttributes: attributesCollection.! !

!JASVGITagConnector methodsFor: 'Accessing' stamp: 'BrunoBB 09/09/2016 05:10'!
startPoint
	^startPoint! !

!JASVGITagConnector methodsFor: 'Updating' stamp: 'BrunoBB 09/09/2016 05:10'!
startPoint: newValue
	startPoint := newValue! !

!JASVGITagConnector methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:21'!
startPoint: startPointTag endPoint: endPointTag

	^self startId: startPointTag id endId: endPointTag id! !

!JASVGITagConnector methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:10'!
svgTag

	^'connector'! !

!JASVGITagElement class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 06:58'!
newId: id withAll: anOrderedCollection

	^super new initialize
		id: id;
		setAttributes: anOrderedCollection;
		yourself! !

!JASVGITagElement class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:15'!
styleAttributesNames

	^#()! !

!JASVGITagElement class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:30'!
withAll: anOrderedCollection

	^super new initialize
		setAttributes: anOrderedCollection;
		yourself! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:46'!
add: aJASVGIAttribute

	^attributes at: aJASVGIAttribute attributeName put: aJASVGIAttribute! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:30'!
addAll: aCollection

	^attributes addAll: aCollection! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 10/10/2016 12:27'!
addAttribute: association

	^self add: (JASVGIAttribute parent: self  name: association key value: association value)! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:30'!
addSubTag: aJASVGITag

	^subTags at: aJASVGITag id put: aJASVGITag! !

!JASVGITagElement methodsFor: 'draw' stamp: 'BrunoBB 09/10/2016 12:20'!
asSvgAttributes
	| svgAttributes styles |

	svgAttributes := OrderedCollection new.
	styles := PrintStream on: String new.

	attributes do: [:each | 
		each isStyleAttribute
		ifTrue: [styles nextPutAll: (each attributeName, ': ', each getAttributeValue,';')] 
		ifFalse: [svgAttributes add: each asSvgAttribute]].

	svgAttributes 
		add: ('id' -> id);
		add: ('style' -> styles contents).

	^svgAttributes! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 15:30'!
attributes
	^attributes! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 15:30'!
attributes: newValue
	attributes := newValue! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 15:20'!
center

	^(self x + (self width // 2)) @ (self y + (self height //2))! !

!JASVGITagElement methodsFor: 'draw' stamp: 'BrunoBB 09/06/2016 15:30'!
drawOn: aJASVGICanvas

	aJASVGICanvas tag: self svgTag attributes: self asSvgAttributes! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 09:34'!
getAttributeNamed: aString

	^attributes detect: [:each | each attributeName = aString] ifNone: [nil]! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:19'!
getStyleAttribute

	^attributes detect: [:each | each svgTag = 'style'] ifNone: [nil]! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:30'!
hasSubTags

	^subTags notEmpty! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:41'!
height
	^(self getAttributeNamed: 'height') attributeValue! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 15:30'!
id
	^id! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 15:30'!
id: newValue
	id := newValue! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:30'!
initialize

	super initialize.

	attributes := Dictionary new.
	subTags := Dictionary new.! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:35'!
position

	^(self x) @ (self y)! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 15:30'!
setAttributes: aCollection

	aCollection do: [:each | attributes at: each attributeName put: each]! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 04:46'!
setMarker: markerId

	self add: (JASVGIAttribute 
						parent: self 
						name: 'marker' 
						value: 'url(#', markerId, ')'
				)! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:32'!
setMarkerEnd: markerId

	self add: (JASVGIAttribute 
						parent: self 
						name: 'marker-end' 
						value: 'url(#', markerId, ')'
				)! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:32'!
setMarkerStart: markerId

	self add: (JASVGIAttribute 
						parent: self 
						name: 'marker-start' 
						value: 'url(#', markerId, ')'
				)! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:14'!
styleAttributesNames

	^self class styleAttributesNames! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 15:30'!
subTags
	^subTags! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 15:30'!
subTags: newValue
	subTags := newValue! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:30'!
svgTag

	^self subclassResponsibility! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 15:06'!
transform: transformationString

	^self add: (JASVGIAttribute parent: self name: 'transform' value: transformationString)! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:40'!
width
	^(self getAttributeNamed: 'width') attributeValue! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:40'!
x
	^(self getAttributeNamed: 'x') attributeValue! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:40'!
y
	^(self getAttributeNamed: 'y') attributeValue! !

JASVGITagElement subclass: #JASVGITagFigure
	instanceVariableNames: 'connectorPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

JASVGITagFigure subclass: #JASVGITagCircle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagCircle class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:30'!
newAsConnectorAt: aPoint 

	^self newAt: aPoint 
			id: UUID new asString
			r: 5 
			fillColor: 'black' 
			stroke: 'black' 
			strokeWidth: 0! !

!JASVGITagCircle class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 06:28'!
newAt: aPoint id: id r: radius fillColor: fillColor stroke: stroke strokeWidth: strokeWidth
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		add: (JASVGIAttribute parent: self name: 'cx' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'cy' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'r' value: radius);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'stroke-width' value: strokeWidth);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
center

	^(self x) @ (self y)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
getBottomMiddlePoint

	^(self x) @ (self y + self height)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
getLeftMiddlePoint

	^(self x - self width) @ (self y)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
getRightMiddlePoint

	^(self x + self width) @ (self y)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
getTopMiddlePoint

	^(self x) @ (self y - self height)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:58'!
height
	^(self getAttributeNamed: 'r') attributeValue! !

!JASVGITagCircle methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:26'!
svgTag

	^'circle'! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:58'!
width
	^(self getAttributeNamed: 'r') attributeValue! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:56'!
x
	^(self getAttributeNamed: 'cx') attributeValue! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:56'!
y
	^(self getAttributeNamed: 'cy') attributeValue! !

JASVGITagFigure subclass: #JASVGITagEllipse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagEllipse class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 10:08'!
newAt: aPoint id: id rx: rx ry: ry fillColor: fillColor stroke: stroke strokeWidth: strokeWidth
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		add: (JASVGIAttribute parent: self name: 'cx' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'cy' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'rx' value: rx);
		add: (JASVGIAttribute parent: self name: 'ry' value: ry);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'strokeWidth' value: strokeWidth);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagEllipse methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 10:06'!
svgTag

	^'ellipse'! !

!JASVGITagFigure class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 09:50'!
styleAttributesNames

	^#('fill' 'stroke' 'stroke-width' 'marker-end' 'marker-start')! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 09:28'!
addConnectorPoint: aJasvgiTagFigure
	"NOT Supported by the standart "

	^connectorPoints at: aJasvgiTagFigure id put: aJasvgiTagFigure! !

!JASVGITagFigure methodsFor: 'Accessing' stamp: 'BrunoBB 09/09/2016 04:38'!
connectorPoints
	^connectorPoints! !

!JASVGITagFigure methodsFor: 'Updating' stamp: 'BrunoBB 09/09/2016 04:38'!
connectorPoints: newValue
	connectorPoints := newValue! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:06'!
drawOn: aJASVGICanvas

	aJASVGICanvas 
		tag: self svgTag 
		attributes: self asSvgAttributes 
		with: [connectorPoints do: [:each | 
					aJASVGICanvas tag: each svgTag attributes: each asSvgAttributes]
		].! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 12:50'!
drawOnListOf: aJasvgiCanvas

	^aJasvgiCanvas addFigure: self! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 11:29'!
drawOnListOf: aJasvgiCanvas in: groupNamed

	^aJasvgiCanvas addFigure: self toGroup: groupNamed! !

!JASVGITagFigure methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:59'!
getBottomMiddlePoint

	^((self x + (self width //2)) @ ((self y + self height)))! !

!JASVGITagFigure methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:59'!
getLeftMiddlePoint

	^((self x) @ ((self y + (self height//2))))! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/27/2016 15:39'!
getPointToConnectTo: aJasvgiTagElement
	"Answer a point of the receiver to connect with the element <aJasvgiTagElement>"

	((self x + self width + 10) < aJasvgiTagElement x) ifTrue: [^self getRightMiddlePoint].

	((self y + self height + 10) < aJasvgiTagElement y) ifTrue: [^self getBottomMiddlePoint].

	((self x) > (aJasvgiTagElement x + aJasvgiTagElement width + 10)) ifTrue: [^self getLeftMiddlePoint].

	((self y) > (aJasvgiTagElement y + aJasvgiTagElement height + 10)) ifTrue: [^self getTopMiddlePoint].

	^(self x + self width//2) @ (self y + self height//2)! !

!JASVGITagFigure methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:59'!
getRightMiddlePoint

	^((self x + self width) @ ((self y + (self height//2))))! !

!JASVGITagFigure methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:59'!
getTopMiddlePoint

	^((self x + (self width //2)) @ self y)! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 04:39'!
initialize

	super initialize.

	connectorPoints := Dictionary new.! !

JASVGITagFigure subclass: #JASVGITagLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagLine class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 13:14'!
newLineFrom: originPoint to: finalPoint

	^self newLineFrom: originPoint to: finalPoint id: UUID new asString widthPx: '1px' stroke: 'black' fillColor: 'black'! !

!JASVGITagLine class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 13:15'!
newLineFrom: originPoint to: finalPoint id: id

	^self newLineFrom: originPoint to: finalPoint id: id widthPx: '1px' stroke: 'black' fillColor: 'black'! !

!JASVGITagLine class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 14:41'!
newLineFrom: originPoint to: finalPoint id: id color: color

	^self newLineFrom: originPoint to: finalPoint id: id widthPx: '1px' stroke: 'yellow' fillColor: color! !

!JASVGITagLine class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 14:42'!
newLineFrom: originPoint to: finalPoint id: id stroke: stroke

	^self newLineFrom: originPoint to: finalPoint id: id widthPx: '1px' stroke: stroke fillColor: 'black'! !

!JASVGITagLine class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 14:41'!
newLineFrom: originPoint to: finalPoint id: id stroke: stroke color: color

	^self newLineFrom: originPoint to: finalPoint id: id widthPx: '1px' stroke: stroke fillColor: color! !

!JASVGITagLine class methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 14:36'!
newLineFrom: originPoint to: finalPoint id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"Draw a Moveto line"
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x1' value: originPoint x);
		add: (JASVGIAttribute parent: self name: 'y1' value: originPoint y);
		add: (JASVGIAttribute parent: self name: 'x2' value: finalPoint x);
		add: (JASVGIAttribute parent: self name: 'y2' value: finalPoint y);
		add: (JASVGIAttribute parent: self name: 'stroke-width' value: widthPx);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagLine methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 13:13'!
svgTag

	^'line'! !

JASVGITagFigure subclass: #JASVGITagPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagPoint class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:35'!
newBottomId: id markerId: markerId
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: '50%');
		add: (JASVGIAttribute parent: self name: 'y' value: '100%');
		add: (JASVGIAttribute parent: self name: 'marker' value: 'url(#',markerId,')');
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPoint class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:33'!
newLeftId: id markerId: markerId
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: '0%');
		add: (JASVGIAttribute parent: self name: 'y' value: '50%');
		add: (JASVGIAttribute parent: self name: 'marker' value: 'url(#',markerId,')');
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPoint class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:33'!
newRightId: id markerId: markerId
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: '100%');
		add: (JASVGIAttribute parent: self name: 'y' value: '50%');
		add: (JASVGIAttribute parent: self name: 'marker' value: 'url(#',markerId,')');
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPoint class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:32'!
newTopId: id markerId: markerId
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: '50%');
		add: (JASVGIAttribute parent: self name: 'y' value: '0%');
		add: (JASVGIAttribute parent: self name: 'marker' value: 'url(#',markerId,')');
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPoint methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 13:13'!
svgTag

	^'point'! !

JASVGITagFigure subclass: #JASVGITagRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagRectangle class methodsFor: 'other' stamp: 'BrunoBB 10/01/2016 09:00'!
newAt: aPoint id: id width: width height: height stroke: stroke fillColor: fillColor

	^self newAt: aPoint id: id width: width height: height strokeWidth: '1px' stroke: stroke fillColor: fillColor! !

!JASVGITagRectangle class methodsFor: 'other' stamp: 'BrunoBB 10/01/2016 08:59'!
newAt: aPoint id: id width: width height: height strokeWidth: widthPx stroke: stroke fillColor: fillColor
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'y' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		add: (JASVGIAttribute parent: self name: 'height' value: height);
		add: (JASVGIAttribute parent: self name: 'width' value: width);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'stroke-width' value: widthPx);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagRectangle class methodsFor: 'other' stamp: 'BrunoBB 10/01/2016 09:04'!
newRoundAt: aPoint id: id width: width height: height rx: rx ry: ry strokeWidth: widthPx stroke: stroke fillColor: fillColor
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'y' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'rx' value: rx);
		add: (JASVGIAttribute parent: self name: 'ry' value: ry);
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		add: (JASVGIAttribute parent: self name: 'height' value: height);
		add: (JASVGIAttribute parent: self name: 'width' value: width);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'stroke-width' value: widthPx);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagRectangle class methodsFor: 'other' stamp: 'BrunoBB 10/01/2016 08:53'!
newRoundAt: aPoint id: id width: width height: height stroke: stroke fillColor: fillColor

	^self newRoundAt: aPoint id: id width: width height: height strokeWidth: '1px' stroke: stroke fillColor: fillColor! !

!JASVGITagRectangle class methodsFor: 'other' stamp: 'BrunoBB 10/01/2016 09:05'!
newRoundAt: aPoint id: id width: width height: height strokeWidth: widthPx stroke: stroke fillColor: fillColor

	^self newRoundAt: aPoint id: id width: width height: height rx: 5 ry: 5 strokeWidth: widthPx stroke: stroke fillColor: fillColor! !

!JASVGITagRectangle methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:43'!
getBottomLine

	^Array 
		with: ((self x + self height) @ self y)
		with: ((self x + self height) @ (self y + self height))! !

!JASVGITagRectangle methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:44'!
getLeftLine

	^Array 
		with: self position
		with: ((self x) @ (self y + self height))! !

!JASVGITagRectangle methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:45'!
getRightLine

	^Array 
		with: ((self x + self width) @ (self y))
		with: ((self x + self width) @ (self y + self height))! !

!JASVGITagRectangle methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:37'!
getTopLine

	^Array 
		with: self position 
		with: ((self x + self width) @ self y)! !

!JASVGITagRectangle methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:26'!
svgTag

	^'rect'! !

JASVGITagElement subclass: #JASVGITagGroup
	instanceVariableNames: 'name svgFigures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagGroup class methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 12:30'!
newNamed: aString

	^super new initialize 
		name: aString;
		yourself! !

!JASVGITagGroup class methodsFor: 'other' stamp: 'BrunoBB 09/19/2016 15:48'!
newNamed: aString id: id

	^super new initialize 
		name: aString;
		id: id;
		yourself! !

!JASVGITagGroup class methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 11:12'!
newNamed: aString with: aJasvgiTagFigure

	^super new initialize 
		name: aString;
		addFigure: aJasvgiTagFigure;
		yourself! !

!JASVGITagGroup methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 11:10'!
addFigure: tagFigure

	^svgFigures at: tagFigure id put: tagFigure! !

!JASVGITagGroup methodsFor: 'draw' stamp: 'BrunoBB 09/18/2016 14:42'!
drawOn: aJASVGICanvas

	aJASVGICanvas 
		tag: self svgTag 
		attributes: self asSvgAttributes 
		with: [self figuresDo: [:eachF | eachF drawOn: aJASVGICanvas]]! !

!JASVGITagGroup methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 12:14'!
figuresDo: aBlock

	^svgFigures do: aBlock! !

!JASVGITagGroup methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 11:10'!
initialize

	super initialize.

	svgFigures := OrderPreservingDictionary new.! !

!JASVGITagGroup methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 11:10'!
name
	^name! !

!JASVGITagGroup methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 11:10'!
name: newValue
	name := newValue! !

!JASVGITagGroup methodsFor: 'Accessing' stamp: 'BrunoBB 09/11/2016 11:10'!
svgFigures
	^svgFigures! !

!JASVGITagGroup methodsFor: 'Updating' stamp: 'BrunoBB 09/11/2016 11:10'!
svgFigures: newValue
	svgFigures := newValue! !

!JASVGITagGroup methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 11:10'!
svgTag

	^'g'! !

JASVGITagElement subclass: #JASVGITagMarker
	instanceVariableNames: 'figure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagMarker class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:56'!
newArrowAt: aPoint id: id width: width height: height
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'markerWidth' value: width);
		add: (JASVGIAttribute parent: self name: 'markerHeight' value: height);
		add: (JASVGIAttribute parent: self name: 'refX' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'refY' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'orient' value: 'auto');
		yourself.

	^super new initialize
		id: id;
		setAttributes: attributes;
		setBlackArrow;
		yourself! !

!JASVGITagMarker class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:23'!
newCircleAt: aPoint id: id width: width height: height
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'markerWidth' value: width);
		add: (JASVGIAttribute parent: self name: 'markerHeight' value: height);
		add: (JASVGIAttribute parent: self name: 'refX' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'refY' value: aPoint y);
		yourself.

	^super new initialize
		id: id;
		setAttributes: attributes;
		setBlackCircle;
		yourself! !

!JASVGITagMarker class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:23'!
newCircleAt: aPoint width: width height: height

	^self newCircleAt: aPoint id: UUID new asString width: width height: height! !

!JASVGITagMarker methodsFor: 'draw' stamp: 'BrunoBB 09/07/2016 08:13'!
drawOn: aJASVGICanvas

	aJASVGICanvas 
		tag: self svgTag 
		attributes: self asSvgAttributes 
		with: [aJASVGICanvas tag: figure svgTag attributes: figure asSvgAttributes]! !

!JASVGITagMarker methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 15:39'!
figure
	^figure! !

!JASVGITagMarker methodsFor: 'Updating' stamp: 'BrunoBB 09/14/2016 11:04'!
figure: newValue

	figure := newValue! !

!JASVGITagMarker methodsFor: 'other' stamp: 'BrunoBB 09/12/2016 09:22'!
setBlackArrow

	figure := JASVGITagPath newLine: 'M1,1 L1,9 L9,5 L1,1' id: 'arrow' widthPx: '1px' stroke: 'black' fillColor: 'black'! !

!JASVGITagMarker methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:32'!
setBlackCircle

	figure := JASVGITagCircle newAsConnectorAt: 5@5! !

!JASVGITagMarker methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:39'!
svgTag

	^'marker'! !

JASVGITagElement subclass: #JASVGITagPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/24/2016 16:43'!
newCurve: points id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"Draw a Moveto line"

	^self newCurve: points type: 'S' id: id widthPx: widthPx stroke: stroke fillColor: fillColor! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/29/2016 16:26'!
newCurve: points type: type id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"Draw a Moveto line"
	| pointsString colorString count |

	"pointsString := PrintStream on: (String withAll: 'M')."
	pointsString := PrintStream on: (String withAll: type).
	colorString := fillColor ifNil: ['black'] ifNotNil: [fillColor].

	count := 1.
	points do: [:eachPoint | 
		"(count = 2) ifTrue: [pointsString nextPutAll: type]. "
		pointsString nextPutAll: (eachPoint x printString, ',', eachPoint y printString), ' '.
		count := count + 1].

	^self newLine: pointsString contents id: id widthPx: widthPx stroke: stroke fillColor: 'none'! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/12/2016 08:51'!
newLine: pointsString id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"Draw a Moveto line"
	| attributes colorString |

	colorString := fillColor ifNil: ['black'] ifNotNil: [fillColor].

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'd' value: pointsString);
		add: (JASVGIAttribute parent: self name: 'stroke-width' value: widthPx);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'fill' value: colorString);
		"add: (JASVGIAttribute parent: self name: 'fill-opacity' value: '1');
		add: (JASVGIAttribute parent: self name: 'stroke-opacity' value: 0.5);"
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 08:48'!
newLineM: points

	^self newLineM: points id: UUID new asString! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 13:07'!
newLineM: points id: id

	^self newLineM: points id: id widthPx: '1px'! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 13:06'!
newLineM: points id: id widthPx: width

	^self newLineM: points id: id widthPx: width stroke: 'gray' fillColor: 'black'! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 15:13'!
newLineM: points id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"Draw a Moveto line"
	| pointsString colorString |

	pointsString := PrintStream on: (String withAll: 'M').
	colorString := fillColor ifNil: ['black'] ifNotNil: [fillColor].

	points do: [:eachPoint | pointsString nextPutAll: (eachPoint x printString, ',', eachPoint y printString), ' '].

	^self newLine: pointsString contents id: id widthPx: widthPx stroke: stroke fillColor: 'none'! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:10'!
styleAttributesNames

	^#('fill' 'stroke' 'stroke-width' 'marker-start' 'marker-end')! !

!JASVGITagPath methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 12:50'!
drawOnListOf: aJasvgiCanvas

	^aJasvgiCanvas addLine: self! !

!JASVGITagPath methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 11:29'!
drawOnListOf: aJasvgiCanvas in: groupNamed

	^aJasvgiCanvas addFigure: self toGroup: groupNamed! !

!JASVGITagPath methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:27'!
svgTag

	^'path'! !

JASVGITagElement subclass: #JASVGITagText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagText class methodsFor: 'other' stamp: 'BrunoBB 09/12/2016 09:34'!
defaultTextSize

	^'14px'! !

!JASVGITagText class methodsFor: 'other' stamp: 'BrunoBB 09/12/2016 09:33'!
newText: aString at: aPoint id: id 

	^self newText: aString at: aPoint id: id textSizePx: self defaultTextSize! !

!JASVGITagText class methodsFor: 'other' stamp: 'BrunoBB 10/01/2016 10:49'!
newText: aString at: aPoint id: id textSizePx: textSizePx

	^self newText: aString at: aPoint id: id textSizePx: textSizePx color: 'black'! !

!JASVGITagText class methodsFor: 'other' stamp: 'BrunoBB 10/01/2016 10:49'!
newText: aString at: aPoint id: id textSizePx: textSizePx color: color
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'y' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'font-size' value: textSizePx);
		add: (JASVGIAttribute parent: self name: 'font-family' value: 'Tahoma');
		add: (JASVGIAttribute parent: self name: 'fill' value: color);
		yourself.

	^(JASVGITagText newId: id withAll: attributes) text: aString! !

!JASVGITagText class methodsFor: 'other' stamp: 'BrunoBB 09/12/2016 14:09'!
newText: aString at: aPoint textSizePx: textSizePx

	^self newText: aString at: aPoint id: UUID new asString textSizePx: textSizePx! !

!JASVGITagText class methodsFor: 'other' stamp: 'BrunoBB 10/01/2016 10:48'!
styleAttributesNames

	^#('fill' 'stroke' 'font-size' 'writing-mode' 'word-spacing' 'letter-spacing' 'kerning' 'text-anchor' 'font-family')! !

!JASVGITagText methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:29'!
drawOn: aJASVGICanvas

	aJASVGICanvas tag: self svgTag attributes: self asSvgAttributes with: text! !

!JASVGITagText methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 12:51'!
drawOnListOf: aJasvgiCanvas

	^aJasvgiCanvas addFigure: self! !

!JASVGITagText methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 11:29'!
drawOnListOf: aJasvgiCanvas in: groupNamed

	^aJasvgiCanvas addFigure: self toGroup: groupNamed! !

!JASVGITagText methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:32'!
svgTag

	^'text'! !

!JASVGITagText methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 13:53'!
text
	^text! !

!JASVGITagText methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 13:53'!
text: newValue
	text := newValue! !
